package parcours;

import grapheX.Arc;
import grapheX.Graphe;
import grapheX.Sommet;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;

/**
 * Cette classe dfinit un parcours simple de graphes
 * contenant des arcs inverses et plusieurs arcs entre deux sommets donns.
 * @author blay
 *
 */
public class ParcoursSimple {

	Graphe graphe;


	public ParcoursSimple(Graphe graphe) {
		super();
		this.graphe = graphe;
	}

	
	
	/**
	 * @param origine
	 * @return une liste de chemin
	 * Cette mthode renvoie les chemins les plus longs possibles  partir du point d'orgine
	 */
	public ArrayList<Chemin> chemins(Sommet origine){
		HashMap<Sommet,ArrayList<Arc>> dejaVu = new HashMap<Sommet, ArrayList<Arc>>();
		ArrayList<Chemin> chemins = new ArrayList<Chemin>();
		chemins = chemins(origine,dejaVu);
		return chemins;
	}

	public ArrayList<Chemin> chemins(Sommet origine, HashMap<Sommet,ArrayList<Arc>> dejaVu){
		//System.out.println("chemins partant de " + origine +"?" + "avec " + dejaVu);
		//System.out.println("XXXXXXXXXXXXXXXXXXXXXX On a deja vu " + dejaVu);	
		ArrayList<Chemin> chemins = new ArrayList<Chemin>();

		if  (dejaVu.containsKey(origine)){
			//System.out.println("DEJA CALCULE" + origine +" : "+  chemins);	
			return chemins;
		}

		//System.out.println("On ajoute l'origine  la liste des chemins deja vus" + origine +" : "+  chemins);	
		dejaVu.put(origine, new ArrayList<Arc>());


		Collection<Arc<Sommet>> voisins = graphe.voisins(origine);	
		//System.out.println(" les voisins  tester" + voisins +"?");		

		HashMap<Sommet,ArrayList<Arc>> dejavVuLocal = new HashMap<Sommet, ArrayList<Arc>>();

		//System.out.println("=======================================================");
		for (Arc<Sommet> a : voisins) {
			//System.out.println("======> boucle sur "+ a+ "en partant de " + origine);
			Sommet destination = a.destination();
			//System.out.println("======> on met  jour les listes locales avec "+ dejaVu + " la place de " +dejavVuLocal);
			dejavVuLocal= new HashMap<Sommet,ArrayList<Arc>>(dejaVu);
			//System.out.println("======> " + dejavVuLocal);

			if (nouvelleDestinationOuNouvelArcSansRetour(origine,dejavVuLocal,destination,a)) { 
				//System.out.println("Nouveau arc  ajouter au chemin :" + a); 
				dejavVuLocal.get(origine).add(a);
				//System.out.println("On cherche d'autre chemin partant de destintation :" + destination); 
				ArrayList<Chemin> cheminsLocaux = chemins(destination,dejavVuLocal);

				if (cheminsLocaux.isEmpty()) {
					Chemin chemin = new Chemin();
					chemins.add(chemin);
					chemin.add(a);
					//System.out.println("On a ajoute un arc  chemins : " + chemins);
				}
				else {
					for (Chemin c : cheminsLocaux) {
						c.add(0,a);
						chemins.add(c);
					}
					
					//chemins.addAll(cheminsLocaux);
					//System.out.println("chemins calculs" + chemins);
				}
			}
/*			else {
				System.out.println("==> On a deja vu " + destination +" ou  " + a);	
				//Chemin chemin = new Chemin();
				//chemin.add(a);
				//chemins.add(chemin);
			}*/
		}
		return chemins;
	}

	private boolean nouvelleDestinationOuNouvelArcSansRetour(
			Sommet origine, HashMap<Sommet, ArrayList<Arc>> dejaVu, Sommet destination,
			Arc<Sommet> a) {
		/*		System.out.println("------------- deja vu " + dejaVu);
		System.out.println("origine " + origine);
		System.out.println("destination " + destination);
		System.out.println("on teste " + a);
		System.out.println("est-ce une destination nouvelle : " + ! dejaVu.containsKey(destination));
		System.out.println("====");*/
		if (! dejaVu.containsKey(destination) )
			return true;
		//System.out.println("==== : " + a);
		ArrayList<Arc> x = dejaVu.get(destination);
		/*System.out.println(">>>> : " + x);
			System.out.println(">>>> : " + x.contains(a));
			System.out.println("est-ce un arc nouveau  " + (! dejaVu.get(destination).contains(a)));
			System.out.println("et la destination de arc pas encore etudiee " + (! dejaVu.containsKey(a.destination()) ) );
		 */
		return ( (! dejaVu.get(destination).contains(a)) && (! dejaVu.containsKey(a.destination()) ) );
	}
}
